Subject: Re: JPEG in INVITE

From: Michael Thomas <[email-masked]>
Date: Sun, 2 Jan 2000 10:04:23 -0800 (PST)

Jonathan Rosenberg writes:
 > The issue is, if the content is referenced by indirection, is it better
 > to be in the body or in a header. Henning is arguing in favor of a
 > header. I agree with him that this is simpler. Both he and Dan are also
 > arguing that we need a way to identify the purpose of the content.
 > Providing such data also argues for it being a header. My concern,
 > though, is that there are so many uses for displaying of content, we
 > have no hope of enumerating them all. I suppose we could enumerate a few
 > and leave others to future standardization. Also, using a URI list in
 > the body is something thats doable now (since we support MIME already),
 > whereas a new header is yet-another-extension that I'd rather avoid. The
 > notion of a generic "body contains content to display", with the body
 > either in-line or referenced via a URI list, is appealing to me because
 > of its generality. Yes, we could have both, but then this seems to make
 > things even more complicated for a designer that now has to choose
 > whether to use the header or the indirect content in the body.

   With UDP, fragmentation, etc, vs other MIME
   headers would they not always have to choose?
 
 > Am I the only one who prefers the indirect references in the body
 > approach?

   I tend to think that URI is a much better
   method overall since the receiving side can
   make a determination of whether they want the 
   content or not, and the timing of fetching 
   the content. However, one thing to be said is 
   that absent an existing IPSEC session between 
   the two hosts (or possibly a third party),
   there will be delay to pay for the indirect
   method. Maybe this extra delay is managable for
   things like X-faces though.

	       Mike

---

From: Anders Kristensen <[email-masked]>
Date: Wed, 05 Jan 2000 18:39:40 +0000

Jonathan Rosenberg wrote:
> Providing such data also argues for it being a header.

I would say that the reason body parts are preferrable over headers is
that we're likely to wish to associate various content descriptors with
the "extra" content, regardless of whether it is included inline or by
reference. There may be a variety of such descriptors, some of them
which we know about now (most of which are probably already
well-defined), and some which we can't imagine now and which may have a
purpose completely unlike other descriptors.

To me it seems to make sense to have a single mechanism for associating
descriptors with directly and indirectly included content (I believe
this is how MHTML works also). This indicates that using MIME body parts
is the more prudent choice here, even though it's tempting to go for the
admittedly simpler but also more shortsighted approach of sticking URLs
into headers.

Incidentally, the X-Face header recognized by some XEmacs mailer holds
an image inline in some obscure bitmap format. The idea was great and
it's a mystery why this isn't a widely supported feature today - maybe
because of the pain involved in generating a decent quality image that
fits in just a couple of hundred bytes.

Anders

-- 
Anders Kristensen <[email-masked]>,
http://www-uk.hpl.hp.com/people/ak/
Hewlett-Packard Labs, Bristol, UK